''**************************
''*  Apple TV Driver Test  *
''*  (C) 2009 Jim Bagley.  *
''**************************

CON

_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
_stack = (100) >> 2   'accomodate display memory and stack

HYBRIDPINS=%011_0000
PROTOBOARDPINS=%001_0101
HYDRAPINS=%011_0000

PAL=1
NTSC=0

mode = NTSC 'NTSC=0 'PAL=1
modepins = HYBRIDPINS 'PROTOBOARDPINS

my_hx=10+((mode&1)<<1)

OBJ
  tv    : "JB_APPLE_TV.spin"

VAR
  long  txtx,txty
    
PUB Main | i,x,y

  i:=0
  repeat y from 0 to 23
    repeat x from 0 to 39
      Screen[((y&7)*128)+((y/8)*40)+x]:=i'//96+32 '(i//10)+"0"
      i++

  tv.start(@tvparams)

  printat(string("Hello World"),0,23)

  repeat

    AppleTVMode:=0
    Repeat 5*60
      WaitVSync

    AppleTVMode:=1
    Repeat 5*60
      WaitVSync

    AppleTVMode:=2
    Repeat 5*60
      WaitVSync

PUB WaitVSync
    repeat until tvparams<>1
    repeat until tvparams==1
        
PUB plot(x,y,c) | sc
  sc := (((y>>1)&7)<<7)+(((y>>(3+1))*40)+x)
  if(y&1)
    Screen[sc]:=(Screen[sc]&$0f)+(c<<4)     
  else
    Screen[sc]:=(Screen[sc]&$f0)+c     

PUB printat(p,x,y)
  txtx:=x
  txty:=y
  repeat while byte[p][0]<>0
    print_char(byte[p][0])
    p++    

PUB print(p)
  repeat while byte[p][0]<>0
    print_char(byte[p][0])
    p++
  txtx:=0
  if txty<23
    txty++    

PUB print_char(p) | sc
  sc := (((txty)&7)<<7)+((txty>>3)*40)+txtx
  Screen[sc]:=p+128
  txtx++
  if txtx>39
    txtx:=0
    if txty<24
      txty++

DAT

tvparams                long    0               'status
                        long    modepins        'pins ' PROTO/DEMO BOARD = %001_0101 ' HYBRID/HYDRA = %011_0000
                        long    mode            'mode ' PAL=1 ' NTSC=0
                        long    my_hx           'hx
                        long    @bordercolour+$10  'pointer to border colour

                        long    @Screen+$10
                        long    @Font+$10
AppleTVMode             long    0 '0=TextMode,1=Mix,2=Fat Pixels
                        long    $00000702 

bordercolour            long    $02

Screen                  byte    0[1024]

font                    file    "text8x8x96.JB2"